precision mediump float;
varying vec4 v_texCoord;
#ifdef VTG_TEXEL0_EXTS
uniform samplerExternalOES u_sampler0;
#else
uniform sampler2D u_sampler0;
#endif
uniform vec4 u_aOpacity;
uniform mat4 u_ccMatrix;
void main() {
   vec4 color0 = texture2D(u_sampler0, v_texCoord.xy);
#if defined(VTG_TEXEL0_RGBX)
    color0.a = 1.0;
#elif defined(VTG_TEXEL0_BGRX)
    color0 = vec4(color0.bgr, 1.0);
#elif defined(VTG_TEXEL0_BGRA)
    color0 = color0.bgra;
#endif
   vec4 tColor = clamp(u_ccMatrix * color0, 0.0, 1.0);
   tColor *= u_aOpacity.x;
   gl_FragColor = tColor;
}